<template>
  <!-- Step Navigation -->
  <nav class="col-12 mb-5">
    <ul class="stepper">
      <li class="step" :class="{'active': activeStep === 1}">
        <span class="step-number">1</span>
        <span class="step-name">{{ $t('message.metadata.dataset') }}</span>
      </li>
      <hr class="step-divider">
      <li class="step" :class="{'active': activeStep === 2}">
        <span class="step-number">2</span>
        <span class="step-name">{{ $t('message.metadata.distributions') }}</span>
      </li>
      <hr class="step-divider">
      <li class="step" :class="{'active': activeStep === 3}">
        <span class="step-number">3</span>
        <span class="step-name">{{ $t('message.metadata.upload') }}</span>
      </li>
      <hr class="step-divider">
      <li class="step" :class="{'active': activeStep === 4}">
        <span class="step-number">4</span>
        <span class="step-name">{{ $t('message.metadata.review') }}</span>
      </li>
      <span class="arrow position-absolute" style="top:1%;right:1%;">
        <button class="btn btn-light" data-toggle="modal" data-target="#resetFormModal">
          {{ $t('message.datasetDetails.upload.reset') }}
          <i class="material-icons small-icon align-middle text-dark">delete</i>
        </button>
      </span>
    </ul>
    <!-- RESET FORM MODAL -->
    <div class="modal fade" id="resetFormModal" tabindex="-1" role="dialog" aria-labelledby="resetFormModalLabel" aria-hidden="true">
      <div class="modal-dialog modal-dialog-centered" role="document">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title" id="resetFormModalLabel">{{ $t('message.datasetDetails.upload.resetText') }}</h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
              <span aria-hidden="true">&times;</span>
            </button>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-secondary" data-dismiss="modal">{{ $t('message.metadata.no') }}</button>
            <button type="button" @click="resetForm()" data-dismiss="modal" class="btn btn-primary">{{ $t('message.metadata.yes') }}</button>
          </div>
        </div>
      </div>
    </div>
  </nav>
</template>

<script>
  /* eslint-disable no-alert */
  import { mapActions, mapGetters } from 'vuex';

  export default {
    name: 'EDP2-uploadPage-top',
    components: {},
    data() {
      return {};
    },
    props: {
      activeStep: {
        type: Number,
        default: 1,
      },
    },
    computed: {
      ...mapGetters('upload', [
        'getValidate',
      ]),
      query() {
        if (typeof this.$route.query.catalog === 'string') return { catalog: this.$route.query.catalog, showcataloguedetails: 'true', locale: this.$route.query.locale };
        return { locale: this.$route.query.locale };
      },
    },
    methods: {
      ...mapActions('upload', [
        'resetStore',
        'setStep',
        'setValidate',
      ]),
      resetForm() {
        this.resetLocalStorage();
        this.resetStore();
      },
      resetLocalStorage() {
        // Clear local storage
        if (localStorage.getItem('catalogue')) {
          localStorage.setItem('catalogue', '');
        }
        if (localStorage.getItem('title')) {
          localStorage.setItem('title', '');
        }
        if (localStorage.getItem('description')) {
          localStorage.setItem('description', '');
        }
        if (localStorage.getItem('keywords')) {
          localStorage.setItem('keywords', '');
        }
        if (localStorage.getItem('categories')) {
          localStorage.setItem('categories', '');
        }
        if (localStorage.getItem('contact')) {
          localStorage.setItem('contact', '');
        }
        if (localStorage.getItem('publisher')) {
          localStorage.setItem('publisher', '');
        }
        if (localStorage.getItem('apiUploadData')) {
          localStorage.setItem('apiUploadData', '');
        }
        if (localStorage.getItem('ID')) {
          localStorage.setItem('ID', '');
        }
        if (localStorage.getItem('distributions')) {
          localStorage.setItem('distributions', '');
        }
        if (localStorage.getItem('distribution')) {
          localStorage.setItem('distribution', '');
        }
        if (localStorage.getItem('files')) {
          localStorage.setItem('files', '');
        }
        // Refresh page
        if (this.$route.name === 'UploadPageDatasetDetails') this.$router.go();
        else this.$router.push({ name: 'UploadPageDatasetDetails', query: this.query });
      },
      scrollToTop() {
        window.scrollTo(0, 0);
      },
    },
    watch: {
      getValidate: {
        // Scroll to top of the current page when validating to show errors
        handler(validate) {
          if (validate) this.scrollToTop();
        },
      },
    },
  };
</script>

<style scoped lang='scss'>
  @import '../../styles/bootstrap_theme';

  .stepper {
    width: 100% !important;
    list-style: none !important;
    text-align: center !important;
    cursor: default !important;
    .step {
      display: inline-flex;
      margin: 0;
      .step-number {
        background-color: $secondary !important;
        color: white !important;
        padding: 8px 15px !important;
        border-radius: 50% !important;
      }
      .step-name {
        display: flex;
        align-items: center;
        margin-left: 5%;
      }
      &.active {
        .step-number {
          background-color: $primary !important;
          font-weight: bold !important;
        }
        .step-name {
          text-decoration: underline !important;
        }
      }
    }
    .step-divider {
      display: inline-block !important;
      width: 75px !important;
      margin: 20px 0 5px 10px !important;
    }
  }

  .heading, .arrow {
    cursor: pointer;
  }
  
  .breadcrumb-item a {
    color: black !important;
    font-size: 18px !important;
  }

  .active {
    font-weight: bold !important;
  }
</style>
